#include "stdlib.h"
#include "stdio.h" 
#include "fxlib.h"

#include "MonochromeLib.h"
#include "key.h"
#include "time.h"

#include "objetcs.h"

char normal[] = {3,0,6,128,4,128,2,128,7,0,11,0,11,128,9,192,9,32,14,0,6,0,6,4,7,2,127,252,14,2,255,252};
char jump[] = {3,0,6,128,4,128,2,128,7,0,11,0,11,128,9,192,6,32,6,4,7,2,255,252,2,0,6,2,7,1,127,254};
char fall[] = {0,0,0,192,1,32,1,32,1,32,52,204,75,48,36,2,36,5,18,9,18,18,9,36,137,72,126,19,1,252,0,0};
char shadow[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,192,31,240,63,248,127,252,63,248,31,240,7,192,0,0,0,0};
char * hero_bmp[] = {normal, jump, fall, shadow};

char boat_left[] = {0,0,0,0,0,0,0,0,64,0,64,0,64,29,64,28,32,28,32,56,127,255,128,0,159,255,143,240,64,7,127,248};
char boat_right[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,64,0,32,0,254,0,1,0,134,0,56,0,192,0,0,0};
char * boat_bmp[] = {boat_left, boat_right};

char cloud[] = {28,112,99,136,128,4,128,8,184,80,71,160,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
char cloud_cache[] = {255,255,227,143,128,7,128,15,184,95,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255};

char * cloud_bmp[] = {cloud, cloud_cache};

char stone[] = {0,0,0,0,56,70,149,161};
char water[] = {0,0,28,227,0,0,0,0};


char* int2str(char* c, unsigned int n) {
    if(n==0) {
        c[0] = '0';
        c[1] = 0;
    } else {
        int i, l=0;
        for(i=n ; i ; i/=10)
            l++;
        c[l] = 0;
        for(i=n ; i ; i/=10)
            c[--l] = i%10+'0';
    }
    return c;
}

void game_over() {
	int i;
	PrintXY(35, 22, "Game Over", 0);
	ML_display_vram();
	IsKeyDown(KEY_CTRL_EXE);
	while(i != KEY_CTRL_EXE) GetKey(&i);
}

void pause() {
	int i, j;
	char* vram = ML_vram_adress();
	char bmp[] = {255, 255, 255, 255, 255, 255, 255, 255, 195, 140, 152, 67, 201, 36, 147, 207, 195, 4, 152, 199, 207, 36, 158, 79, 207, 38, 48, 195, 255, 255, 255, 255, 255, 255, 255, 255};
	for(i=0 ; i<9 ; i++) {
		for(j=0 ; j<4 ; j++)
			vram[(i+28<<4)+j+6] = bmp[(i<<2)+j];
	}
	IsKeyDown(KEY_CTRL_EXE);
	while(i != KEY_CTRL_EXE) GetKey(&i);
}

int hero_aabb(Hero * hero, int x, int y) {
	if( x >= hero->x+8 && x <= hero->x + 15 && y >= hero->y + 8 && y <= hero->y + 15 )
		return 1;
	else
		return 0;
}

int AddIn_main(int isAppli, unsigned short OptionNum) {	
	
	// helpers
	int i;
	int hero_x, hero_y;	
	// sun vars
	int sun_x = 110, sun_y = -10;
	int sun_last_tick = 0;	
	// hud (pts + fps)
	char fps_char[10], points_char[50];
	int fps = 0, fps_frame, fps_last_time;	
	// game vars
	int gameover = 0;
	int points = 0;
	int mainmenu = 1;
	
	// init
	Hero * hero = hero_create(hero_bmp);	
	Boat * boat = boat_create(boat_bmp);	
	Water * waters[6];	
	Stone * stones[60];
	Bird * bird = bird_create();
	Cloud * cloud = cloud_create(cloud_bmp);
	int stones_dy = -2, stones_last_tick = 0;	
	for(i = 0; i < 6; i++)
		waters[i] = water_create(hero, i+1); 
	map_load(stones, 1); // first map
	
	while(1) {
		////// MENU BEGIN HERE	
		ML_clear_vram();
		
		/// Update
		
		// boat
		if(!hero->is_fall)
			boat_update(boat);
		
		// water
		if(!hero->is_jmp && !hero->is_fall) {
			for(i = 0; i < 6; i++) {
				water_update(waters[i]);
				if(waters[i]->y > waters[i]->y_stop) {
					water_reset(hero, waters[i]);
				}
			}
		}
		
		// bird
		bird_update(bird);
		
		// cloud
		cloud_update(cloud);
		
		// menu key
		if(key_down(K_EXE))
			mainmenu = 0;
			
		/// Draw
		hero_x = (int) hero->x;
		hero_y = (int) hero->y;
		
		// horizon
		ML_horizontal_line(62/3, 0, 127, ML_BLACK);
		
		// hero
		ML_bmp_16_or_cl(hero->bmp[hero->bmp_current], hero_x, hero_y);		
		
		// boat
		boat_draw(boat);
		
		// rope hero<->boat
		ML_line(hero_x+10, hero_y+8, boat->x, boat->y+13, ML_BLACK);
		
		// water
		if(!hero->is_jmp && !hero->is_fall) {
			for(i = 0; i < 6; i++) {
				water_draw(waters[i]);
			}
		}
		
		// sun
		if(sun_x > -20) {
			ML_circle(sun_x, sun_y, 20, ML_BLACK);
			ML_line(sun_x - 19, 0, sun_x - 27, 0, ML_BLACK);
			ML_line(sun_x + 19, 0, sun_x + 27, 0, ML_BLACK);
			ML_line(sun_x - 10, 10, sun_x - 16, 16, ML_BLACK);
			ML_line(sun_x + 10, 10, sun_x + 16, 16, ML_BLACK);
		}
		
		// cloud
		cloud_draw(cloud);
		
		// bird
		bird_draw(bird);
		
		// text
		PrintMini(30, 26, "press EXE to start", 0);
		
		/// Pause
		if(key_down(K_EXIT))
			pause();		
		
		ML_display_vram();		
		Sleep(10);
		////// MENU END HERE
		
		////// GAME BEGIN HERE
		
		while(!mainmenu && !gameover) {
			ML_clear_vram();
			
			/// Update
			// hero
			if(!hero->is_jmp && !hero->is_fall) {
				if(key_down(K_DOWN)) {
					hero->y += 0.8;
				}
				if(hero->y > 64 - 16) hero->y = 64 - 16;
				if(key_down(K_UP)) {
					hero->y -= 0.8;
				}
				if(hero->y < 16) hero->y = 16;
			}
			if(key_down(K_SHIFT) && !hero->is_fall) {
				hero_jump_start(hero);
			}
			hero_update(hero);
			
			// boat
			if(!hero->is_fall)
				boat_update(boat);

			// water
			if(!hero->is_jmp && !hero->is_fall) {
				for(i = 0; i < 6; i++) {
					water_update(waters[i]);
					if(waters[i]->y > waters[i]->y_stop) {
						water_reset(hero, waters[i]);
					}
				}
			}
			
			// sun
			if(!hero->is_fall && sun_x > -20 && time_getTicks() - sun_last_tick > 100) {
				sun_x -= 1;
				sun_last_tick = time_getTicks();
			}
			
			// stone
			if(time_getTicks() - stones_last_tick > 2) {
				for(i = 0; i < 60; i++) {	
					stones[i]->x += stones_dy;
					
					// check collision with current stone
					if( !hero->is_jmp && !hero->is_fall && stones[i]->x < hero->x + 18 && stones[i]->x > hero->x - 5 && (
						hero_aabb(hero, stones[i]->x, stones[i]->y) || hero_aabb(hero, stones[i]->x+7, stones[i]->y) || hero_aabb(hero, stones[i]->x, stones[i]->y+7) || hero_aabb(hero, stones[i]->x+7, stones[i]->y+7)
					) ) {
						gameover = 1;
						hero_falling_start(hero);
					}
				}			
				
				if(stones[59]->x < -8) {
					map_free(stones);
					
					srand(time_getTicks()+5645673); // next map type
					if(rand()%5 == 0)
						i = 1;
					else
						i = 2;
						
					map_load(stones, i);
				}
				
				// Score
				if(!gameover) {
					points += 3;
				}
				
				stones_last_tick = time_getTicks();
			}
			
			// bird
			bird_update(bird);
			
			// cloud
			cloud_update(cloud);
			
			/// Draw
			hero_x = (int) hero->x;
			hero_y = (int) hero->y;
			
			// horizon
			ML_horizontal_line(62/3, 0, 127, ML_BLACK);
			
			// sun
			if(sun_x > -20) {
				ML_circle(sun_x, sun_y, 20, ML_BLACK);
				ML_line(sun_x - 19, 0, sun_x - 27, 0, ML_BLACK);
				ML_line(sun_x + 19, 0, sun_x + 27, 0, ML_BLACK);
				ML_line(sun_x - 10, 10, sun_x - 16, 16, ML_BLACK);
				ML_line(sun_x + 10, 10, sun_x + 16, 16, ML_BLACK);
			}
			
			// cloud
			cloud_draw(cloud);
			
			// bird
			bird_draw(bird);
			
			// stone
			for(i = 0; i < 60; i++) {
				if(stones[i]->x > -8 && stones[i]->x < 130)
					ML_bmp_8_or_cl(stone, stones[i]->x, stones[i]->y);
			}
			
			// hero
			ML_bmp_16_or_cl(hero->bmp[hero->bmp_current], hero_x, hero_y);
			if(hero->is_jmp) {
				ML_bmp_16_or_cl(hero->bmp[3], hero_x, hero->y_stop);
			}			
			// boat
			boat_draw(boat);
			
			// water
			if(!hero->is_jmp && !hero->is_fall) {
				for(i = 0; i < 6; i++) {
					water_draw(waters[i]);
				}
			}
			
			// rope hero<->boat
			ML_line(hero_x+10, hero_y+8, boat->x, boat->y+13, ML_BLACK);
			
			// Hud
			int2str(fps_char, fps);	
			PrintMini(127-15, 1, fps_char, 0);
			
			int2str(points_char, (int) points);
			PrintMini(1, 1, points_char, 0);
			
			/// Pause
			if(key_down(K_EXIT))
				pause();
			
			// Fps
			if(time_getTicks()-fps_last_time>128) { 
				fps = fps_frame;
				if(fps < 0 || fps > 1000) fps = 0;
				fps_frame = 0;
				fps_last_time = time_getTicks();
			}
			fps_frame++;
			
			if(gameover) {
				stones_dy = 0;
				
				game_over();
				
				hero_reset(hero);
				boat_reset(boat);
				map_free(stones);
				map_load(stones, 1);
				
				sun_x = 110;
				sun_y = -10;
				sun_last_tick = 0;
				
				bird_reset(bird);
				cloud_reset(cloud);
				
				stones_dy = -2;
				stones_last_tick = 0;
				
				points = 0;			
				gameover = 0;
				mainmenu = 1;
				
				Sleep(200); // anti auto exe (cause autostart of game !)
				Sleep(200);
				Sleep(200);
			}
			
			ML_display_vram();		
			Sleep(10);
		}
		
		////// GAME END HERE
	}
}

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section

#pragma section _TOP

int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section