#ifndef _HERO
#define _HERO

typedef struct {
	double x, y;
	double dx, dy;
	double ax, ay;

	char position;
	
	int y_stop;
	
	char is_jmp, is_fall;
	
	unsigned char ** bmp;
	char bmp_current;
	
	int tick_last;
	
	int TICK_NEXT; // "constant" : (tick_current - tick_last > TICK_NEXT) : update
} Hero;

typedef struct {
	int x, y;
	char position; // 1 = top ; 2 = low	
	
	unsigned char ** bmp;
	
	int tick_last;
	
	int TICK_NEXT; // "constant" : (tick_current - tick_last > TICK_NEXT) : update
} Boat;

typedef struct {
	double x, y;
	double dx, dy;
	double ax, ay;
	
	int y_stop;
	
	char type; // 1 = top ; 2 = middle ; 3 = low
	
	int tick_last;
	
	int TICK_NEXT; // "constant" : (tick_current - tick_last > TICK_NEXT) : update
} Water;

typedef struct {
	int x, y;
	int dx;
	char position; // 1 = top ; 2 = low	
	
	int tick_last;
} Bird;

typedef struct {
	int x, y;
	int dx;
	
	unsigned char ** bmp;
	
	int tick_last;
} Cloud;

typedef struct {
	int x, y;
} Stone;

Hero * hero_create(unsigned char ** bmp);
void hero_reset(Hero * hero);
void hero_jump_start(Hero * hero);
void hero_jump_reset(Hero * hero);
void hero_falling_start(Hero * hero);
void hero_update(Hero * hero);

Boat * boat_create(unsigned char ** bmp);
void boat_reset(Boat * boat);
void boat_draw(Boat * boat);
void boat_update(Boat * boat);

Water * water_create(Hero * hero, char type);
void water_reset(Hero * hero, Water * water);
void water_draw(Water * water);
void water_update(Water * water);

void map_load(Stone * stones[60], char type);
void map_free(Stone * stones[60]);

Bird * bird_create();
void bird_reset(Bird * bird);
void bird_draw(Bird * bird);
void bird_update(Bird * bird);

Cloud * cloud_create(unsigned char ** bmp);
void cloud_reset(Cloud * cloud);
void cloud_draw(Cloud * cloud);
void cloud_update(Cloud * cloud);

#endif //_HERO

